@echo off
REM @Name g3e.Publish-metadata.bat
REM @Author S.Deckers
REM @Date 14 September 2010
REM @Purpose Publish metadata
REM ------------------------------------------------------------------------------------------------------------

REM Test Usage (20100301 SDE)
REM -------------------------
if "%2" == "" ( echo Usage:pmData.bat -conf RR [-p A/M/P/D] [-o C] && goto :EOF)

REM Fetch publishmode (20101224 SDE)
REM --------------------------------
set publishMode=%4%
if /i "%publishMode%" == ""  	( set publishMode=All) 		&& goto :OPTIMIZED_TABLES
if /i "%publishMode%" == "A"  	( set publishMode=All) 		&& goto :OPTIMIZED_TABLES
if /i "%publishMode%" == "M"  	( set publishMode=Metadata) 	&& goto :OPTIMIZED_TABLES
if /i "%publishMode%" == "P"  	( set publishMode=Picklist) 	&& goto :OPTIMIZED_TABLES
if /i "%publishMode%" == "D"  	( set publishMode=Default) 	&& goto :OPTIMIZED_TABLES
echo Unsupported publishmode [%publishMode%]  && goto :EOF

REM Optimized table argument. Default is to recreate them (20101226 SDE)
REM -------------------------------------------------------------------
:OPTIMIZED_TABLES
set optables=%6%
if /i "%optables%" == "C" (
	set optables=-C
) else (
	set optables=
)

REM Fetch args (20100301 SDE)
REM -------------------------
:SET_CONFIGURATION
set conf=%2%
if /i "%conf%" == "RR" 		( goto :RR)

echo Unsupported configuration [%conf%] && goto :EOF

REM RR (20110804 SDE)
REM ----------------
:RR
set CON=rr/rr@ORCL
set DDC_METADATA=C:\Mapfiles\RR\Metadata
set CONFIGURATION=RR
goto :POST_METADATA

REM General locations
REM -----------------
:POST_METADATA
if "%PROCESSOR_ARCHITECTURE%"=="AMD64" (
	set GT_PRODUCT_DIR="C:\Program Files (x86)\Intergraph\GTechnology"
) ELSE (
	set GT_PRODUCT_DIR="C:\Program Files\Intergraph\GTechnology"
)

REM Test existence (20091124 SDE)
REM -----------------------------
if not exist %DDC_METADATA% 	( echo Can't open [%DDC_METADATA%] 	&& goto :EOF)
if not exist %GT_PRODUCT_DIR% 	( echo Can't open [%GT_PRODUCT_DIR%] 	&& goto :EOF)

REM Create stamp for moving old metadata folder.
REM Note:If you assing the variables used for the name of the folder the old metadata is moved to inside
REM the If statement which actually is nicer because they only are used over there and so you use the minimal
REM needed scope, the very first time the batch file is called the value is not assigned (20120919 SDE)
REM ---------------------------------------------------------------------------------------------------
set YEAR=%date:~6,4%
set MONTH=%date:~3,2%
set DAY=%date:~0,2%
set HOUR=%time: =0%
set HOUR_ZERO=%HOUR:~0,2%
set MINUTE=%time:~3,2%
set SECOND=%time:~6,2%
set STAMP=%YEAR%%MONTH%%DAY%-%HOUR_ZERO%%MINUTE%%SECOND%

REM Move 0009 folder if fullpublishing. Short data format should be dd/MM/yyyy (20120124 SDE)
REM -----------------------------------------------------------------------------------------
if /i "%publishMode%" == "All" (
	if exist %DDC_METADATA%\0009 	(
		echo STAMP : %STAMP%
		move "%DDC_METADATA%\0009" "%DDC_METADATA%\0009.%STAMP%"
	)
)

REM Remove old logfile (20130709 SDE)
REM ---------------------------------
set LOGFILE=%TEMP%\mpublishVMESDEV.log
if exist %LOGFILE% (
	echo Removing file [%LOGFILE%]
	del %LOGFILE%
)

REM Publish metadata (20100727 SDE)
REM -------------------------------
echo Publishing metadata %optables% -s %CONFIGURATION% %DDC_METADATA% %PUBLISHMODE% %CON%
pushd %GT_PRODUCT_DIR%\Program
set STARTTIME=%TIME%
echo Start    : %STARTTIME%
publishMetadataMapfiles %optables% -s %CONFIGURATION% %DDC_METADATA% %PUBLISHMODE% %CON%
popd

REM Finished
REM --------
set ENDTIME=%TIME% 
echo End      : %ENDTIME%

REM Calculate duration
REM -------------------
set /A STARTTIME=(1%STARTTIME:~0,2%-100)*360000 + (1%STARTTIME:~3,2%-100)*6000 + (1%STARTTIME:~6,2%-100)*100 + (1%STARTTIME:~9,2%-100)
set /A ENDTIME=(1%ENDTIME:~0,2%-100)*360000 + (1%ENDTIME:~3,2%-100)*6000 + (1%ENDTIME:~6,2%-100)*100 + (1%ENDTIME:~9,2%-100)
set /A DURATION=%ENDTIME%-%STARTTIME%

if %ENDTIME% LSS %STARTTIME% set set /A DURATION=%STARTTIME%-%ENDTIME%

set /A DURATIONH=%DURATION% / 360000
set /A DURATIONM=(%DURATION% - %DURATIONH%*360000) / 6000
set /A DURATIONS=(%DURATION% - %DURATIONH%*360000 - %DURATIONM%*6000) / 100
set /A DURATIONHS=(%DURATION% - %DURATIONH%*360000 - %DURATIONM%*6000 - %DURATIONS%*100)

if %DURATIONH% LSS 10 set DURATIONH=0%DURATIONH%
if %DURATIONM% LSS 10 set DURATIONM=0%DURATIONM%
if %DURATIONS% LSS 10 set DURATIONS=0%DURATIONS%
if %DURATIONHS% LSS 10 set DURATIONHS=0%DURATIONHS%

echo Duration : %DURATIONH%:%DURATIONM%:%DURATIONS%.%DURATIONHS%