/**
 * @Name netviewer_tooltips1.sql
 * @Purpose Netviewer tooltips approach 1
 * @Since 16 April 2014
 * @Author S.Deckers - Merkator
 * @Url www.gtechcorner.com
 */
  
insert into g3e_label( g3e_lfno, 	g3e_username,	g3e_content ) 
			 values  ( 120000,		'V1',			'F[G3E_FID]:[MATERIAL]/[DIAMETER]');

insert into g3e_labelrule( g3e_lrrowno, g3e_lrno, 	g3e_rule, 	g3e_filter, 	g3e_filterordinal, 	g3e_lfno )
			values		 ( 120001,		1,			'R1',		null, 			1, 					120000);

create or replace view V_GASLINE_FE as
    select gas_line.G3E_FID, MATERIAL, DIAMETER 
    from gas_line
    inner join gas_record on gas_record.g3e_fid = gas_line.g3e_fid
    WHERE gas_line.G3E_FNO=12;
                                      
Insert into G3E_COMPONENT	( G3E_CNO, 	G3E_USERNAME, 				G3E_NAME, 		G3E_TOOLTIP, 			G3E_TYPE, 	G3E_TABLE, 		G3E_DETAIL, G3E_DCNO, 	G3E_LRNO, 	G3E_LTT) 
     				values 	( 1204, 	'Gas Line Identifier', 		'V_GASLINE_FE', 'Gas Line Identifier', 	2048, 		'V_GASLINE_FE', 	0, 			1, 			1, 			0);

Insert into G3E_ATTRIBUTE ( G3E_ANO, 	G3E_CNO,  	G3E_FIELD, 	G3E_USERNAME,	G3E_REQUIRED,  G3E_COPY, 	G3E_EXCLUDEFROMEDIT, 	G3E_DATATYPE, 	G3E_EXCLUDEFROMREPLACE,  	G3E_BREAKCOPY, 	G3E_COPYATTRIBUTE, 	G3E_WRAPTEXT, 	G3E_UNIQUE, G3E_FUNCTIONALVALIDATION, 	G3E_ROLE) 
					values( 120401, 	1204, 		'G3E_FID', 	'Fid', 	0, 		0, 			0, 						4, 				0, 							0, 				0, 					1, 				0, 			1, 							'EVERYONE');
Insert into G3E_ATTRIBUTE ( G3E_ANO, 	G3E_CNO,  	G3E_FIELD, 	G3E_USERNAME,	G3E_REQUIRED,  G3E_COPY, 	G3E_EXCLUDEFROMEDIT, 	G3E_DATATYPE, 	G3E_EXCLUDEFROMREPLACE,  	G3E_BREAKCOPY, 	G3E_COPYATTRIBUTE, 	G3E_WRAPTEXT, 	G3E_UNIQUE, G3E_FUNCTIONALVALIDATION, 	G3E_ROLE) 
					values( 120402, 	1204, 		'MATERIAL',	'Material', 	0, 				0, 			0, 						4, 				0, 							0, 				0, 					1, 				0, 			1, 							'EVERYONE');
Insert into G3E_ATTRIBUTE ( G3E_ANO, 	G3E_CNO,  	G3E_FIELD, 	G3E_USERNAME,	G3E_REQUIRED,  G3E_COPY, 	G3E_EXCLUDEFROMEDIT, 	G3E_DATATYPE, 	G3E_EXCLUDEFROMREPLACE,  	G3E_BREAKCOPY, 	G3E_COPYATTRIBUTE, 	G3E_WRAPTEXT, 	G3E_UNIQUE, G3E_FUNCTIONALVALIDATION, 	G3E_ROLE) 
					values( 120403, 	1204, 		'DIAMETER', 'Diameter', 	0, 				0, 			0, 						4, 				0, 							0, 				0, 					1, 				0, 			1, 							'EVERYONE');

update g3e_feature set g3e_identifierview = 'V_GASLINE_FE' where g3e_fno = 12;
update g3e_component set g3e_lrno = 1 where g3e_cno in ( 1201, 1202, 1203 ); 		--- skip cno 1204, but you may as well specify an g3e_lrno for it.(20140416 SDE)

COMMIT;