/**
 * @Name simple Gas-line.sql
 * @Purpose A gasline
 * @Date 3 April 2014
 * @Author S.Deckers - Merkator
 * @Url www.gtechcorner.com
 * @Description A simple gasline
 */ 
 
CREATE TABLE GAS_LINE
(
  G3E_ID      	NUMBER( 10)		NOT NULL,
  G3E_FNO     	NUMBER( 5)		NOT NULL,
  G3E_FID     	NUMBER( 10)		NOT NULL,
  G3E_CNO     	NUMBER( 5)		NOT NULL,
  G3E_CID     	NUMBER( 10)		NOT NULL,
  G3E_GEOMETRY  SDO_GEOMETRY
);

Insert into G3E_COMPONENT	( G3E_CNO, 	G3E_USERNAME, 	G3E_NAME, 	G3E_TOOLTIP, 	G3E_TYPE, 			G3E_GEOMETRYTYPE, 				G3E_TABLE,		G3E_DETAIL, G3E_DCNO, 	G3E_GEOMETRYFIELD, 	G3E_LTT)
                Values   	( 1201,    	'Gas Line','GAS_LINE', 'Gas Line tt',4 /*spatial line*/,	'CompositePolylineGeometry',  	'GAS_LINE',   	0,     		1,     		'G3E_GEOMETRY',		1);
 
insert into G3E_ATTRIBUTE	( G3E_ANO, 	G3E_CNO, 	G3E_FIELD, 		G3E_USERNAME,			G3E_FORMAT, 		G3E_REQUIRED, 	G3E_HYPERTEXT, 	G3E_COPY, 	G3E_EXCLUDEFROMEDIT, 	G3E_DATATYPE, 	G3E_EXCLUDEFROMREPLACE, G3E_BREAKCOPY, 	G3E_COPYATTRIBUTE, 	G3E_WRAPTEXT, 	G3E_UNIQUE, G3E_FUNCTIONALVALIDATION)
                values		( 120101,	1201,		'G3E_ID',		'Identifier', 			'General Number',	0,				0,				0,			1,						3,				0,						0,				0,					1,				0,			0);                                        
insert into G3E_ATTRIBUTE	( G3E_ANO, 	G3E_CNO, 	G3E_FIELD, 		G3E_USERNAME,			G3E_FORMAT, 		G3E_REQUIRED, 	G3E_HYPERTEXT, 	G3E_COPY, 	G3E_EXCLUDEFROMEDIT, 	G3E_DATATYPE, 	G3E_EXCLUDEFROMREPLACE, G3E_BREAKCOPY, 	G3E_COPYATTRIBUTE, 	G3E_WRAPTEXT, 	G3E_UNIQUE, G3E_FUNCTIONALVALIDATION)
                values		( 120102,	1201,		'G3E_FNO',		'Feature number', 		'General Number',	0,				0,				0,			1,						3,				0,						0,				0,					1,				0,			0);                        
insert into G3E_ATTRIBUTE	( G3E_ANO, 	G3E_CNO, 	G3E_FIELD, 		G3E_USERNAME,			G3E_FORMAT, 	 	G3E_REQUIRED, 	G3E_HYPERTEXT, 	G3E_COPY, 	G3E_EXCLUDEFROMEDIT, 	G3E_DATATYPE, 	G3E_EXCLUDEFROMREPLACE, G3E_BREAKCOPY, 	G3E_COPYATTRIBUTE, 	G3E_WRAPTEXT, 	G3E_UNIQUE, G3E_FUNCTIONALVALIDATION)
                values		( 120103,	1201,		'G3E_FID',		'Feature Identifier', 	'General Number',	0,				0,				0,			1,						3,				0,						0,				0,					1,				0,			0);                        
insert into G3E_ATTRIBUTE	( G3E_ANO, 	G3E_CNO, 	G3E_FIELD, 		G3E_USERNAME,			G3E_FORMAT, 	 	G3E_REQUIRED, 	G3E_HYPERTEXT, 	G3E_COPY, 	G3E_EXCLUDEFROMEDIT, 	G3E_DATATYPE, 	G3E_EXCLUDEFROMREPLACE, G3E_BREAKCOPY, 	G3E_COPYATTRIBUTE, 	G3E_WRAPTEXT, 	G3E_UNIQUE, G3E_FUNCTIONALVALIDATION)
                values		( 120104,	1201,		'G3E_CNO',		'Component number', 	'General Number',	0,				0,				0,			1,						3,				0,						0,				0,					1,				0,			0);                        
insert into G3E_ATTRIBUTE	( G3E_ANO, 	G3E_CNO, 	G3E_FIELD, 		G3E_USERNAME,			G3E_FORMAT, 	 	G3E_REQUIRED, 	G3E_HYPERTEXT, 	G3E_COPY, 	G3E_EXCLUDEFROMEDIT, 	G3E_DATATYPE, 	G3E_EXCLUDEFROMREPLACE, G3E_BREAKCOPY, 	G3E_COPYATTRIBUTE, 	G3E_WRAPTEXT, 	G3E_UNIQUE, G3E_FUNCTIONALVALIDATION)
                values		( 120105,	1201,		'G3E_CID',		'Component identifier', 'General Number',	0,				0,				0,			1,						3,				0,						0,				0,					1,				0,			0);                        
insert into G3E_ATTRIBUTE	( G3E_ANO, 	G3E_CNO, 	G3E_FIELD, 		G3E_USERNAME,			G3E_FORMAT, 	 	G3E_REQUIRED, 	G3E_HYPERTEXT, 	G3E_COPY, 	G3E_EXCLUDEFROMEDIT, 	G3E_DATATYPE, 	G3E_EXCLUDEFROMREPLACE, G3E_BREAKCOPY, 	G3E_COPYATTRIBUTE, 	G3E_WRAPTEXT, 	G3E_UNIQUE, G3E_FUNCTIONALVALIDATION)
                values		( 120106,	1201,		'G3E_GEOMETRY',	'Geometry', 			NULL,				1,				0,				0,			1,						32,				0,						1,				0,					1,				0,			0);                        

CREATE TABLE GAS_RECORD
(
  G3E_ID      	NUMBER( 10)		NOT NULL,
  G3E_FNO     	NUMBER( 5)		NOT NULL,
  G3E_FID     	NUMBER( 10)		NOT NULL,
  G3E_CNO     	NUMBER( 5)		NOT NULL,
  G3E_CID     	NUMBER( 10)		NOT NULL,
  DIAMETER	NUMBER( 10)		NOT NULL,
  MATERIAL	VARCHAR(15)		NOT NULL
);

Insert into G3E_COMPONENT	( G3E_CNO, 	G3E_USERNAME, 		G3E_NAME, 		G3E_TOOLTIP, 		G3E_TYPE, 			G3E_GEOMETRYTYPE, 	G3E_TABLE,		G3E_DETAIL, G3E_DCNO, 	G3E_GEOMETRYFIELD, 	G3E_LTT)
                Values   	( 1202,    	'Gas Rec',	'GAS_RECORD', 	'Gas Rec tt', 	1 /* nongraphic */,	NULL,  				'GAS_RECORD',  	0,     		1,     		NULL,				1);
 
insert into G3E_ATTRIBUTE	( G3E_ANO, 	G3E_CNO, 	G3E_FIELD, 		G3E_USERNAME,			G3E_FORMAT, 		G3E_REQUIRED, 	G3E_HYPERTEXT, 	G3E_COPY, 	G3E_EXCLUDEFROMEDIT, 	G3E_DATATYPE, 	G3E_EXCLUDEFROMREPLACE, G3E_BREAKCOPY, 	G3E_COPYATTRIBUTE, 	G3E_WRAPTEXT, 	G3E_UNIQUE, G3E_FUNCTIONALVALIDATION)
                values		( 120201,	1202,		'G3E_ID',		'Identifier', 			'General Number',	0,				0,				0,			1,						3,				0,						0,				0,					1,				0,			0);                                        
insert into G3E_ATTRIBUTE	( G3E_ANO, 	G3E_CNO, 	G3E_FIELD, 		G3E_USERNAME,			G3E_FORMAT, 		G3E_REQUIRED, 	G3E_HYPERTEXT, 	G3E_COPY, 	G3E_EXCLUDEFROMEDIT, 	G3E_DATATYPE, 	G3E_EXCLUDEFROMREPLACE, G3E_BREAKCOPY, 	G3E_COPYATTRIBUTE, 	G3E_WRAPTEXT, 	G3E_UNIQUE, G3E_FUNCTIONALVALIDATION)
                values		( 120202,	1202,		'G3E_FNO',		'Feature number', 		'General Number',	0,				0,				0,			1,						3,				0,						0,				0,					1,				0,			0);                        
insert into G3E_ATTRIBUTE	( G3E_ANO, 	G3E_CNO, 	G3E_FIELD, 		G3E_USERNAME,			G3E_FORMAT, 	 	G3E_REQUIRED, 	G3E_HYPERTEXT, 	G3E_COPY, 	G3E_EXCLUDEFROMEDIT, 	G3E_DATATYPE, 	G3E_EXCLUDEFROMREPLACE, G3E_BREAKCOPY, 	G3E_COPYATTRIBUTE, 	G3E_WRAPTEXT, 	G3E_UNIQUE, G3E_FUNCTIONALVALIDATION)
                values		( 120203,	1202,		'G3E_FID',		'Feature Identifier', 	'General Number',	0,				0,				0,			1,						3,				0,						0,				0,					1,				0,			0);                        
insert into G3E_ATTRIBUTE	( G3E_ANO, 	G3E_CNO, 	G3E_FIELD, 		G3E_USERNAME,			G3E_FORMAT, 	 	G3E_REQUIRED, 	G3E_HYPERTEXT, 	G3E_COPY, 	G3E_EXCLUDEFROMEDIT, 	G3E_DATATYPE, 	G3E_EXCLUDEFROMREPLACE, G3E_BREAKCOPY, 	G3E_COPYATTRIBUTE, 	G3E_WRAPTEXT, 	G3E_UNIQUE, G3E_FUNCTIONALVALIDATION)
                values		( 120204,	1202,		'G3E_CNO',		'Component number', 	'General Number',	0,				0,				0,			1,						3,				0,						0,				0,					1,				0,			0);                        
insert into G3E_ATTRIBUTE	( G3E_ANO, 	G3E_CNO, 	G3E_FIELD, 		G3E_USERNAME,			G3E_FORMAT, 	 	G3E_REQUIRED, 	G3E_HYPERTEXT, 	G3E_COPY, 	G3E_EXCLUDEFROMEDIT, 	G3E_DATATYPE, 	G3E_EXCLUDEFROMREPLACE, G3E_BREAKCOPY, 	G3E_COPYATTRIBUTE, 	G3E_WRAPTEXT, 	G3E_UNIQUE, G3E_FUNCTIONALVALIDATION)
                values		( 120205,	1202,		'G3E_CID',		'Component identifier', 'General Number',	0,				0,				0,			1,						3,				0,						0,				0,					1,				0,			0);                        
insert into G3E_ATTRIBUTE	( G3E_ANO, 	G3E_CNO, 	G3E_FIELD, 		G3E_USERNAME,			G3E_FORMAT, 	 	G3E_REQUIRED, 	G3E_HYPERTEXT, 	G3E_COPY, 	G3E_EXCLUDEFROMEDIT, 	G3E_DATATYPE, 	G3E_EXCLUDEFROMREPLACE, G3E_BREAKCOPY, 	G3E_COPYATTRIBUTE, 	G3E_WRAPTEXT, 	G3E_UNIQUE, G3E_FUNCTIONALVALIDATION)
                values		( 120206,	1202,		'DIAMETER',		'Diameter', 			null,				0,				0,				0,			1,						10,				0,						1,				0,					1,				0,			0);                        
insert into G3E_ATTRIBUTE	( G3E_ANO, 	G3E_CNO, 	G3E_FIELD, 		G3E_USERNAME,			G3E_FORMAT, 	 	G3E_REQUIRED, 	G3E_HYPERTEXT, 	G3E_COPY, 	G3E_EXCLUDEFROMEDIT, 	G3E_DATATYPE, 	G3E_EXCLUDEFROMREPLACE, G3E_BREAKCOPY, 	G3E_COPYATTRIBUTE, 	G3E_WRAPTEXT, 	G3E_UNIQUE, G3E_FUNCTIONALVALIDATION)
                values		( 120207,	1202,		'MATERIAL',		'Material', 			null,				0,				0,				0,			1,						10,				0,						1,				0,					1,				0,			0);                        

insert into G3E_FEATURE( G3E_FNO,	G3E_USERNAME,	G3E_TOOLTIP,		G3E_PRIMARYGEOGRAPHICCNO,	G3E_PRIMARYATTRIBUTECNO, 	G3E_DCNO,	G3E_REPLACE,	G3E_MERGE,	G3E_BULKEDIT ) 
                values ( 12,		'Gas Feat','Gas Feat tt',	1201,						1202,						1,			0,				1,			0	);

insert into G3E_FEATURECOMPONENT	( G3E_FCNO, G3E_FNO, 	G3E_CNO,	G3E_REQUIRED,	G3E_REPEATING,	G3E_AUTOREPEAT,	G3E_PINO,										G3E_ORDINAL,	G3E_INSERTORDINAL,	G3E_DELETEORDINAL,	G3E_REFRESH,	G3E_REPLACE,	G3E_BREAKACTION, 	G3E_COMPONENTELIMINATION,	G3E_COMPONENTASSIGNMENT,	G3E_COMPONENTADJUSTMENT,	G3E_ALTERNATEGEOGRAPHIC,	G3E_ALTERNATEGEOORDINAL,	G3E_INCLUDEINPLACEMENT,	G3E_MERGEOCCURRENCES,	G3E_GENERATE)
                values				( 1201, 	12,			1201,		1,				0,				0,				2 /* Interactive IPT:g3e_placementinterface */,	1,				1,					2,					0,				0,				1,					3,							1,							3,							0,							0,							1,						1,						0);

insert into G3E_FEATURECOMPONENT	( G3E_FCNO, G3E_FNO, 	G3E_CNO,	G3E_REQUIRED,	G3E_REPEATING,	G3E_AUTOREPEAT,	G3E_PINO,										G3E_ORDINAL,	G3E_INSERTORDINAL,	G3E_DELETEORDINAL,	G3E_REFRESH,	G3E_REPLACE,	G3E_BREAKACTION, 	G3E_COMPONENTELIMINATION,	G3E_COMPONENTASSIGNMENT,	G3E_COMPONENTADJUSTMENT,	G3E_ALTERNATEGEOGRAPHIC,	G3E_ALTERNATEGEOORDINAL,	G3E_INCLUDEINPLACEMENT,	G3E_MERGEOCCURRENCES,	G3E_GENERATE)
                values				( 1202, 	12,			1202,		1,				0,				0,				2 /* Interactive IPT:g3e_placementinterface */,	2,				2,					1,					0,				0,				1,					3,							1,							3,							0,							0,							1,						1,						0);

/* --- Dialogs (20131113 SDE)  */

insert into g3e_dialogtab( G3E_DTNO,	G3E_USERNAME, 			G3E_ORIENTATION) 
				  values ( 1201, 		'Gas Line Placement', 	'V');
insert into g3e_dialogtab( G3E_DTNO,	G3E_USERNAME, 			G3E_ORIENTATION) 
				  values ( 1202, 		'Gas Line Edit', 		'V');
insert into g3e_dialogtab( G3E_DTNO,	G3E_USERNAME, 			G3E_ORIENTATION) 
				  values ( 1203, 		'Gas Line Review', 		'V');

insert into g3e_dialog( g3e_drowno, g3e_dno, g3e_type, 		g3e_fno, 	g3e_dtno,	g3e_ordinal )
				values(	1201,		1201,	 'Placement',	12,			1201,		1);
insert into g3e_dialog( g3e_drowno, g3e_dno, g3e_type, 		g3e_fno, 	g3e_dtno,	g3e_ordinal )
				values(	1202,		1202,	 'Edit',		12,			1202,		1);
insert into g3e_dialog( g3e_drowno, g3e_dno, g3e_type, 		g3e_fno, 	g3e_dtno,	g3e_ordinal )
				values(	1203,		1203,	 'Review',		12,			1203,		1);

/* --- Configure 'Placement' menu, then copy to 'Edit'/'Review' (20140403 SDE) */
Insert into g3e_tabattribute( G3E_TANO, G3E_ANO, 	G3E_DTNO,	G3E_PNO,	G3E_ORDINAL,	G3E_READONLY, 	G3E_DEFAULT,	G3E_FIELDVALUEFILTER, 	G3E_REFRESH)
					VALUES 	( 120101, 	120206, 	1201,		null,		1, 				0, 				'', 			'', 					0);

Insert into g3e_tabattribute( G3E_TANO, G3E_ANO, 	G3E_DTNO,	G3E_PNO,	G3E_ORDINAL,	G3E_READONLY, 	G3E_DEFAULT,	G3E_FIELDVALUEFILTER, 	G3E_REFRESH)
					VALUES 	( 120102, 	120207, 	1201,		null,		2, 				0, 				'', 			'', 					0);

Insert into g3e_tabattribute( G3E_TANO, 	G3E_ANO, 	G3E_DTNO,	G3E_PNO,	G3E_ORDINAL,	G3E_READONLY, 	G3E_DEFAULT,	G3E_REFRESH)
					select	G3E_TANO+100,	g3e_ano,	1202,		g3e_pno,	g3e_ordinal,	g3e_readonly,	g3e_default,	g3e_refresh from g3e_tabattribute 
                    where g3e_dtno = 1201;

Insert into g3e_tabattribute( G3E_TANO, 	G3E_ANO, 	G3E_DTNO,	G3E_PNO,	G3E_ORDINAL,	G3E_READONLY, 	G3E_DEFAULT,	G3E_REFRESH)
					select	G3E_TANO+200,	g3e_ano,	1203,		null, 		g3e_ordinal,	1,				g3e_default,	g3e_refresh from g3e_tabattribute 
                    where g3e_dtno = 1201;

/* --- Placement selection (20140304 SDE) */

Insert into G3E_PLACEMENTSELECTION( G3E_PSROWNO, G3E_FNO, 	G3E_USERNAME, 	G3E_LEVEL, 	G3E_ORDINAL, 	G3E_ICONORDINAL)
 						Values    ( 12,			 12, 		'Gas Line', 	1, 			1, 				0);

/* --- Component view definition. At this point, GAS_LINE is still a table after calling G3EOneTable.InstallOneTable it will be a view. I'm creating the component view over here and 
	   populate the optimized table so 'G3EOneTable.InstallOneTable' wil generate a call to MODLOGUTILS.DoModLogDeletesAndInserts in trigger B$GAS_LINEAMT. If you
       create the componentview after calling G3EOneTable.InstallOneTable you need to call 'exec G3E_COMPVIEWCOMP_PKG.CREATEOPTIMIZEDTABLE;' &  
       exec GDOTRIGGERS.CREATE_GDOTRIGGERS	( 'GAS_LINE') ;(20131113 SDE) */

create or replace view V_GAS_LINE
as
	select 	G3E_ID
    	,	G3E_FNO
        ,	G3E_FID
        ,	G3E_CNO
        ,	G3E_CID
        ,	G3E_GEOMETRY
         from GAS_LINE;
    
insert into g3e_componentviewdefinition( g3e_vno, 	g3e_view, 		g3e_fno, 	g3e_cno, 	g3e_leno)
								values(	 1201,		'V_GAS_LINE',	12,			1201, 		null);
                            
insert into g3e_componentviewcomposition( g3e_cvcno, g3e_vno, 	g3e_fno, 	g3e_cno) 
								values	( 120110, 	 1201,		12,			1201);  
         
exec G3E_COMPVIEWCOMP_PKG.CREATEOPTIMIZEDTABLE;
                       
/* --- Generate LTT-views (20140403 SDE) */

exec GPTUtils.PostProcess		( 'FEATURECOMPONENT');
exec GPTUtils.PostProcess		( 'COMPONENT');
exec GPTUtils.PostProcess		( 'ATTRIBUTE');
exec G3EOneTable.InstallOneTable	( 'GAS_LINE');		/* --- Creates B$GAS_LINE, B$GAS_LINE_PKG, GT_CNO_1201_PKG */
exec G3EOneTable.InstallOneTable	( 'GAS_RECORD');	/* --- Creates B$GAS_RECORD, B$GAS_RECORD_PKG, GT_CNO_1202_PKG */
       
/* --- Update drivers (20140403 SDE) */

exec GPTUtils.PostProcess			( 'FEATURECOMPONENT'); 	/* --- Updates G3E_COMPONENTVIEWS_OPTABLE */
exec ComponentViewQuery.Generate;	/* --- Creates packages GT_CV_1001_PKG, GT_CV_1101_PKG, GT_CV_1201_PKG, regenerates body package COMPONENTVIEWQUERYDRIVER 8/

/* --- Styles & Legend(20140403 SDE) */

insert into g3e_linestyle	( g3e_sno, 	g3e_username, 	g3e_color, 				g3e_width)
				values		( 1201,		'Gas Line',		16711680 /* blue */,	2);                

insert into g3e_stylerule	( g3e_srrowno, 	g3e_srno, 	g3e_rule, 				g3e_filterordinal,  g3e_sno ) 
                values		( 1201,			1201,		'Gas Line style rule',	1,					1201 );

insert into g3e_legendentry ( g3e_leno, g3e_legendentry,	g3e_username, 	g3e_vno,	g3e_srno) 
                    values	( 3, 		'Gas Line', 		'Gas Line',		1201,		1201);

insert into G3E_LEGDC1 ( g3e_dcrowno, 	g3e_legenditem, g3e_username, 	g3e_level, 	g3e_ordinal, 	g3e_leafindicator) 
				values ( 3, 			'Gas Line', 	'Gas Line',		1, 			1, 				1); -- 0 (No leaf):No g3e_legendentry, 1 (Leaf):g3e_legendentry row present

insert into G3E_LEGDEF1( g3e_leno, g3e_filter, 	g3e_displayordinal)
				values ( 3,			null,		10);

/* --- Update componentview definition with legend entry (20140403 SDE) */
update g3e_componentviewdefinition set g3e_leno = 3 where g3e_vno = 1201;

/* --- Picklists (20140403 SDE) */

create table VL_GAS_DIAM_MAT
(
   		id 		int	primary key
   ,	diam 	int not null
   ,	mat 	varchar( 20) not null
);

insert into VL_GAS_DIAM_MAT( id, diam, mat) values ( 1,		10,	'GRADE B' );
insert into VL_GAS_DIAM_MAT( id, diam, mat) values ( 2,		12,	'60' );
insert into VL_GAS_DIAM_MAT( id, diam, mat) values ( 3,		30,	'X42' );
insert into VL_GAS_DIAM_MAT( id, diam, mat) values ( 4,		30,	'X56' );
insert into VL_GAS_DIAM_MAT( id, diam, mat) values ( 5,		30,	'X60' );
insert into VL_GAS_DIAM_MAT( id, diam, mat) values ( 6,		30,	'X70' );
insert into VL_GAS_DIAM_MAT( id, diam, mat) values ( 7,		36,	'X42' );
insert into VL_GAS_DIAM_MAT( id, diam, mat) values ( 8,		36,	'X56' );
insert into VL_GAS_DIAM_MAT( id, diam, mat) values ( 9,		36,	'X60' );
insert into VL_GAS_DIAM_MAT( id, diam, mat) values ( 10,	36,	'X70' );
insert into VL_GAS_DIAM_MAT( id, diam, mat) values ( 11,	100,	'GRADE B' );
insert into VL_GAS_DIAM_MAT( id, diam, mat) values ( 12,	100,	'GRADE B of St. 35.29' );
insert into VL_GAS_DIAM_MAT( id, diam, mat) values ( 13,	150,	'GRADE B' );
insert into VL_GAS_DIAM_MAT( id, diam, mat) values ( 14,	150,	'L240 NB/MB' );
insert into VL_GAS_DIAM_MAT( id, diam, mat) values ( 15,	150,	'SenL' );
insert into VL_GAS_DIAM_MAT( id, diam, mat) values ( 16,	1200,	'X60' );
insert into VL_GAS_DIAM_MAT( id, diam, mat) values ( 17,	1200,	'X70' );

insert into G3E_PICKLIST 	( G3E_PNO, 	G3E_USERNAME,	G3E_TABLE,	G3E_KEYFIELD,	G3E_VALUEFIELD, G3E_VALIDATION,   	G3E_ORDERBYKEY, G3E_ADDITIONALFIELDS, 	G3E_PUBLISH)
				Values		( 1, 		'Gas diameter', 'VL_GAS_DIAM_MAT', 	'DIAM', 		'DIAM',			'G3ERestricted', 	'ID',			'MAT',					0); 

insert into G3E_PICKLIST 	( G3E_PNO, 	G3E_USERNAME,	G3E_TABLE,	G3E_KEYFIELD,	G3E_VALUEFIELD, G3E_VALIDATION,   	G3E_ORDERBYKEY, G3E_ADDITIONALFIELDS, 	G3E_PUBLISH)
				Values		( 2, 		'Gas material', 'VL_GAS_DIAM_MAT', 	'MAT', 			'MAT',			'G3ERestricted', 	'ID',			NULL,					0); 

select * from vl_gas_diam_mat;

-- default values for placement menus (20140404 SDE)
update g3e_tabattribute set g3e_default = '10' where g3e_tano = 120101;
update g3e_tabattribute set g3e_default = 'GRADE B' where g3e_tano = 120102;

update g3e_tabattribute set g3e_pno = 1 where g3e_tano in ( 120101, 120201);
update g3e_tabattribute set g3e_pno = 2 where g3e_tano in ( 120102, 120202);

update g3e_tabattribute set g3e_fieldvaluefilter = '(#120206=DIAM|#120206=DIAM)' 		where g3e_tano in ( 120102, 120202); -- Fieldvalue filters for Material

/* --- Publish metadata + data so our componentview is available (20140403 SDE) */

CREATE TABLE GAS_LABEL
(
  G3E_ID      	NUMBER( 10)		NOT NULL,
  G3E_FNO     	NUMBER( 5)		NOT NULL,
  G3E_FID     	NUMBER( 10)		NOT NULL,
  G3E_CNO     	NUMBER( 5)		NOT NULL,
  G3E_CID     	NUMBER( 10)		NOT NULL,
  G3E_ALIGNMENT	NUMBER( 5)		NOT NULL,
  G3E_GEOMETRY  SDO_GEOMETRY
);

Insert into G3E_COMPONENT	( G3E_CNO, 	G3E_USERNAME, 	G3E_NAME, 	G3E_TOOLTIP, 	G3E_TYPE, 				G3E_GEOMETRYTYPE, 		G3E_TABLE,		G3E_ALIGNMENTFIELD,	G3E_DETAIL, G3E_DCNO, 	G3E_GEOMETRYFIELD, 	G3E_LTT)
                Values   	( 1203,    	'Gas Label',	'GAS_LABEL', 'Gas Label tt', 	1024 /*GraphicsText*/,	'TextPointGeometry',  	'GAS_LABEL',   	'G3E_ALIGNMENT',	0,     		1,     		'G3E_GEOMETRY',		1);
 
insert into G3E_ATTRIBUTE	( G3E_ANO, 	G3E_CNO, 	G3E_FIELD, 		G3E_USERNAME,			G3E_FORMAT, 		G3E_REQUIRED, 	G3E_HYPERTEXT, 	G3E_COPY, 	G3E_EXCLUDEFROMEDIT, 	G3E_DATATYPE, 	G3E_EXCLUDEFROMREPLACE, G3E_BREAKCOPY, 	G3E_COPYATTRIBUTE, 	G3E_WRAPTEXT, 	G3E_UNIQUE, G3E_FUNCTIONALVALIDATION)
                values		( 120301,	1203,		'G3E_ID',		'Identifier', 			'General Number',	0,				0,				0,			1,						3,				0,						0,				0,					1,				0,			0);                                        
insert into G3E_ATTRIBUTE	( G3E_ANO, 	G3E_CNO, 	G3E_FIELD, 		G3E_USERNAME,			G3E_FORMAT, 		G3E_REQUIRED, 	G3E_HYPERTEXT, 	G3E_COPY, 	G3E_EXCLUDEFROMEDIT, 	G3E_DATATYPE, 	G3E_EXCLUDEFROMREPLACE, G3E_BREAKCOPY, 	G3E_COPYATTRIBUTE, 	G3E_WRAPTEXT, 	G3E_UNIQUE, G3E_FUNCTIONALVALIDATION)
                values		( 120302,	1203,		'G3E_FNO',		'Feature number', 		'General Number',	0,				0,				0,			1,						3,				0,						0,				0,					1,				0,			0);                        
insert into G3E_ATTRIBUTE	( G3E_ANO, 	G3E_CNO, 	G3E_FIELD, 		G3E_USERNAME,			G3E_FORMAT, 	 	G3E_REQUIRED, 	G3E_HYPERTEXT, 	G3E_COPY, 	G3E_EXCLUDEFROMEDIT, 	G3E_DATATYPE, 	G3E_EXCLUDEFROMREPLACE, G3E_BREAKCOPY, 	G3E_COPYATTRIBUTE, 	G3E_WRAPTEXT, 	G3E_UNIQUE, G3E_FUNCTIONALVALIDATION)
                values		( 120303,	1203,		'G3E_FID',		'Feature Identifier', 	'General Number',	0,				0,				0,			1,						3,				0,						0,				0,					1,				0,			0);                        
insert into G3E_ATTRIBUTE	( G3E_ANO, 	G3E_CNO, 	G3E_FIELD, 		G3E_USERNAME,			G3E_FORMAT, 	 	G3E_REQUIRED, 	G3E_HYPERTEXT, 	G3E_COPY, 	G3E_EXCLUDEFROMEDIT, 	G3E_DATATYPE, 	G3E_EXCLUDEFROMREPLACE, G3E_BREAKCOPY, 	G3E_COPYATTRIBUTE, 	G3E_WRAPTEXT, 	G3E_UNIQUE, G3E_FUNCTIONALVALIDATION)
                values		( 120304,	1203,		'G3E_CNO',		'Component number', 	'General Number',	0,				0,				0,			1,						3,				0,						0,				0,					1,				0,			0);                        
insert into G3E_ATTRIBUTE	( G3E_ANO, 	G3E_CNO, 	G3E_FIELD, 		G3E_USERNAME,			G3E_FORMAT, 	 	G3E_REQUIRED, 	G3E_HYPERTEXT, 	G3E_COPY, 	G3E_EXCLUDEFROMEDIT, 	G3E_DATATYPE, 	G3E_EXCLUDEFROMREPLACE, G3E_BREAKCOPY, 	G3E_COPYATTRIBUTE, 	G3E_WRAPTEXT, 	G3E_UNIQUE, G3E_FUNCTIONALVALIDATION)
                values		( 120305,	1203,		'G3E_CID',		'Component identifier', 'General Number',	0,				0,				0,			1,						3,				0,						0,				0,					1,				0,			0);                        
insert into G3E_ATTRIBUTE	( G3E_ANO, 	G3E_CNO, 	G3E_FIELD, 		G3E_USERNAME,			G3E_FORMAT, 	 	G3E_REQUIRED, 	G3E_HYPERTEXT, 	G3E_COPY, 	G3E_EXCLUDEFROMEDIT, 	G3E_DATATYPE, 	G3E_EXCLUDEFROMREPLACE, G3E_BREAKCOPY, 	G3E_COPYATTRIBUTE, 	G3E_WRAPTEXT, 	G3E_UNIQUE, G3E_FUNCTIONALVALIDATION)
                values		( 120306,	1203,		'G3E_GEOMETRY',	'Geometry', 			NULL,				1,				0,				0,			1,						32,				0,						1,				0,					1,				0,			0);                        
insert into G3E_ATTRIBUTE	( G3E_ANO, 	G3E_CNO, 	G3E_FIELD, 		G3E_USERNAME,			G3E_FORMAT, 	 	G3E_REQUIRED, 	G3E_HYPERTEXT, 	G3E_COPY, 	G3E_EXCLUDEFROMEDIT, 	G3E_DATATYPE, 	G3E_EXCLUDEFROMREPLACE, G3E_BREAKCOPY, 	G3E_COPYATTRIBUTE, 	G3E_WRAPTEXT, 	G3E_UNIQUE, G3E_FUNCTIONALVALIDATION)
                values		( 120307,	1203,		'G3E_ALIGNMENT','Alignment', 			'General Number',	0,				0,				0,			1,						3,				0,						0,				0,					1,				0,			0);                        

insert into G3E_FEATURECOMPONENT	( G3E_FCNO, G3E_FNO, 	G3E_CNO,	G3E_REQUIRED,	G3E_REPEATING,	G3E_AUTOREPEAT,	G3E_PINO,										G3E_ORDINAL,	G3E_INSERTORDINAL,	G3E_DELETEORDINAL,	G3E_REFRESH,	G3E_REPLACE,	G3E_BREAKACTION, 	G3E_COMPONENTELIMINATION,	G3E_COMPONENTASSIGNMENT,	G3E_COMPONENTADJUSTMENT,	G3E_ALTERNATEGEOGRAPHIC,	G3E_ALTERNATEGEOORDINAL,	G3E_INCLUDEINPLACEMENT,	G3E_MERGEOCCURRENCES,	G3E_GENERATE)
                values				( 1203, 	12,			1203,		0,				1,				0,				2 /* Interactive IPT:g3e_placementinterface */,	3,				3,					3,					0,				0,				1,					3,							1,							3,							0,							0,							1,						1,						0);

create or replace view V_GAS_LABEL
as
	select 	GAS_LABEL.G3E_ID
    	,	GAS_LABEL.G3E_FNO
        ,	GAS_LABEL.G3E_FID
        ,	GAS_LABEL.G3E_CNO
        ,	GAS_LABEL.G3E_CID
        ,	GAS_RECORD.DIAMETER
        ,	GAS_RECORD.MATERIAL
        ,	GAS_LABEL.G3E_GEOMETRY
        ,	GAS_LABEL.G3E_ALIGNMENT
         from GAS_LABEL
         INNER JOIN GAS_RECORD on GAS_RECORD.G3E_FID = GAS_LABEL.G3E_FID;       
  
insert into g3e_componentviewdefinition( g3e_vno, 	g3e_view, 		g3e_fno, 	g3e_cno, 	g3e_leno)
								values(	 1203,		'V_GAS_LABEL',	12,			1203, 		null);
                            
insert into g3e_componentviewcomposition( g3e_cvcno, g3e_vno, 	g3e_fno, 	g3e_cno) 
								values	( 120310, 	 1203,		12,			1203);  
                                       
exec GPTUtils.PostProcess			( 'FEATURECOMPONENT');
exec GPTUtils.PostProcess			( 'COMPONENT');
exec GPTUtils.PostProcess			( 'ATTRIBUTE');
exec G3EOneTable.InstallOneTable	( 'GAS_LABEL');	-- B$GAS_LABELAMT

insert into g3e_label( g3e_lfno, 	g3e_username, 			g3e_content ) 
			 values  ( 120301,		'Gas Line Label',		'[[DIAMETER]/[MATERIAL]]');
             
insert into g3e_labelrule( g3e_lrrowno, g3e_lrno, 	g3e_rule, 			g3e_filter, g3e_filterordinal, 	g3e_lfno )
			values		 ( 120301,		10,			'Gas Line Label',	null, 		1, 					120301);

Insert into G3E_TEXTSTYLE( G3E_SNO,	G3E_USERNAME, 	G3E_COLOR, 				G3E_FONTNAME, 	G3E_FONTBOLD, 	G3E_FONTITALIC, G3E_FONTSTRIKETHROUGH, 	G3E_FONTUNDERLINE, 	G3E_FONTWEIGHT, G3E_SIZE, 	G3E_TEXTBOX, 	G3E_TEXTBOXFILLCOLOR, 	G3E_TEXTBOXFILLTYPE, 	G3E_TEXTBOXFRAME, 	G3E_TEXTBOXFRAMECOLOR, 	G3E_TEXTBOXFRAMEWIDTH, 	G3E_PLOTREDLINE, 	G3E_JUSTIFICATION, 	G3E_LEFTTEXTBOXOFFSET, 	G3E_RIGHTTEXTBOXOFFSET, G3E_TOPTEXTBOXOFFSET, 	G3E_BOTTOMTEXTBOXOFFSET, 	G3E_STYLEUNITS, G3E_TEXTBOXFILLTRANSLUCENCY)
 				Values   ( 120301,  'Gas Label',	16711680 /* blue */,  	'Arial',     	0,     			0,     			0,     					0,     				400,     		15.714,     0,     			-3,     				0,     					1,     				0,     					3,     					0,     				1,     				0,     					0,     					0,     					0,     						1,     			100 );

Insert into G3E_STYLERULE( G3E_SRROWNO, G3E_SRNO, 	G3E_RULE, 		G3E_FILTER,	G3E_FILTERORDINAL, 	G3E_SNO,	G3E_DESCRIPTION)
 				Values   ( 120301,     	1,     		'Gas Label',	NULL,		10,     			120301,     'Gas Label' );

insert into g3e_legendentry ( g3e_leno, g3e_legendentry,	g3e_username, 	g3e_vno,	g3e_srno, 	g3e_lrno) 
                    values	( 4, 		'Gas Label', 		'Gas Label',	1203,		1,			10);

insert into G3E_LEGDC1 ( g3e_dcrowno, 	g3e_legenditem,	 	g3e_username, 	g3e_level, 	g3e_ordinal,	g3e_leafindicator) 
				values ( 4, 			'Gas Label', 		'Gas Label',	1, 			1, 				1);

insert into G3E_LEGDEF1( g3e_leno, 	g3e_filter, 	g3e_displayordinal)
				values ( 4,			null,			11);

update g3e_componentviewdefinition set g3e_leno = 4 where g3e_vno = 1203;

commit;


/**
 * @Name cleanup
 * @Purpose cleanup generated definitions
 */
 
delete from g3e_dialogtab where g3e_dtno in ( 1201, 1202, 1203 ); 
delete from g3e_tabattribute where g3e_ano in ( 120206, 120207);
delete from g3e_componentviewdefinition where g3e_view = 'V_GAS_LINE';
drop view V_GAS_LINE; 
delete from g3e_picklist where g3e_pno in ( 1, 2);
drop table VL_GAS_DIAM_MAT;
delete from g3e_stylerule 	where g3e_srrowno = 1201;
delete from g3e_linestyle where g3e_sno = 1201;
delete from G3E_LEGDC1 	where g3e_dcrowno = 3;
delete from g3e_legdef1 where g3e_leno = 3;
delete from g3e_placementselection where g3e_psrowno = 12;
delete from g3e_featurecomponent where g3e_fno = 12;
delete from g3e_attribute where g3e_cno in ( 1201, 1202, 1203 );
delete from g3e_feature where g3e_fno = 12;
delete from g3e_component where G3E_CNO in ( 1201, 1202, 1203 );
drop package B$GAS_LINE_PKG;
drop package B$GAS_RECORD_PKG;
drop view GAS_LINE;
drop view GAS_RECORD;
drop table B$GAS_LINE;
drop table B$GAS_LINE_TMP;
drop table B$GAS_RECORD;
drop table B$GAS_RECORD_TMP;
delete from modificationlog where g3e_fno = 12;
drop package B$GAS_LABEL_PKG;
drop view GAS_LABEL;
drop view V_GAS_LABEL;
drop table B$GAS_LABEL;
drop table B$GAS_LABEL_TMP;
delete from g3e_stylerule where g3e_rule = 'Gas Label';
delete from g3e_textstyle where g3e_username = 'Gas Label';
drop package GT_CNO_1201_PKG;
drop package GT_CNO_1202_PKG;
drop package GT_CNO_1203_PKG;
delete from g3e_labelrule where g3e_lfno = 120301;
delete from g3e_label where g3e_lfno = 120301;